#! /bin/sh

# Expects args: include paths and libs for READLINE
# expects CXX and CXXFLAGS inherited from parent shell

# Check READLINE lin is compatible with CXXFLAGS (from GMP)

if [ "X$CXX" = "X" ]
then
  echo "$0: shell variable CXX must be set (and exported)" >/dev/stderr
  exit 1
fi

cat > test-readline.C <<EOF
#include "stdlib.h"
#include "stdio.h"
#include "unistd.h"
#include "readline/readline.h"
#include "readline/history.h"

#include <string>

int main()
{
  char *line;
  line = readline("");
  std::string str(line);
  free(line);
  // We shall test on an input of 3 chars...
  if (str.size() != 3) return 1;
  return 0;
}
EOF

"$CXX" $CXXFLAGS test-readline.C $* -o test-readline
if [ $? -ne 0 ]
then
  /bin/rm -f test-readline test-readline.C
  exit 1;
fi

cat > test-readline.in <<EOF
abc
EOF

./test-readline < test-readline.in > /dev/null 2>&1
if [ $? -ne 0 ]
then
  /bin/rm -f test-readline test-readline.C test-readline.in
  exit 2;
fi

/bin/rm -f test-readline test-readline.C test-readline.in

exit 0
